#! /bin/sh
#
#   Module name 		: createnv.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.4


# Script name : createnv.sh
# Purpose     : Creates a minimum BBENV file.
# Author      : S. Roberts
# Revision    : 1.00


PATH=$PATH:. ; export PATH

# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


pause()
{
	echo
	echo "$spc Press [RETURN] to continue: \c"
	read nothing
}


set_attrs()
{
	case "$TERM" in
		vt100 | vt220 | vt320 | xterm | ansi )
					st_bl=`tput bold 2>/dev/null`;
					st_us=`tput smul 2>/dev/null`;
					norm=`tput sgr0 2>/dev/null`;;

		* )			st_bl=;
					st_us=;
					norm=;;
	esac
}


menu()
{
	# $1 = Message, $2 = File or Directory, $3 = Path,
	# $4 = Need to exist, $5 = TDF listing
	level_back=false
	message=$1
	f_or_d=$2
	def_path=$3
	need2exist=$4
	is_tdf=$5

	if [ "$is_tdf" = "Go for it" ]
	then
		list_tdfs
	fi

	echo
	echo "$spc DEFAULT $message [$st_bl$def_path$norm]"
	echo "$spc Enter 'q' to QUIT '^' to GO BACK  'd' for DEFAULT or \c"
	if [ $f_or_d = "dir" ]
	then
		echo "NEW DIRECTORY"
	else
		echo "NEW FILE NAME"
	fi
	if [ "$is_tdf" = "No, its banners" ]
	then
		echo "$spc Enter 'c' to create if you have a Licence Banner\c"
		echo " Form for this installation"
	fi
	echo
	ex_flag=false
	while [ $ex_flag = false ]
	do
		echo "$spc Select option: $st_bl\c"
		read choice
		echo "$norm\c"
		case $choice in
			"^" )		ex_flag=true;;
			q | Q )		exit 1;;
			d | D )		choice=$def_path;
					what_if_tdf;
					ex_flag=true;;
			"" )		;;
			* )		check_existance $choice $f_or_d $need2exist "$is_tdf";;
		esac
	done
}


list_tdfs()
{
	curr_dir=`pwd`
	tmp_file=/tmp/mkbbenv.$$
	echo "$st_bl\c" > $tmp_file
	echo "$spc UBL System Software Directory $norm" >> $tmp_file
	cd $ubb_path
	ls -C *.tdf | pr -t -o3 >> $tmp_file
	cd $curr_dir
	echo >> $tmp_file

	if [ $ubb_path != `pwd` ]
	then
		echo "$st_bl\c" >> $tmp_file
		echo "$spc Current Directory $norm" >> $tmp_file
		ls -C *.tdf | pr -t -o3 >> $tmp_file
		echo >> $tmp_file
	fi

	more $tmp_file
	rm -f $tmp_file 2> /dev/null
}


what_if_tdf()
{
	if [ "$is_tdf" = "Go for it" ]
	then
		wheres_the_tdf $choice
	fi
}


wheres_the_tdf()
{
	if [ -z "`echo $1|grep '/'`" ]
	then
		if [ -f `pwd`/$1 ]
		then
			f_name=`pwd`/$1
		else
			f_name=$ubb_path/$1
		fi
	fi
	choice=$f_name
}


check_existance()
{
	f_name=$1
	f_or_d=$2
	need2exist=$3
	is_tdf=$4

	if [ "$is_tdf" = "Go for it" ]
	then
		wheres_the_tdf $f_name
	fi

	if [ "$is_tdf" = "No, its banners" -a \( "$f_name" = "c" -o "$f_name" = "C" \) ]
	then
		need2exist=N
	fi

	if [ $need2exist = Y -o $need2exist = y ]
	then
		if [ "$f_or_d" = "dir" ]
		then
			if [ -d "$f_name" ]
			then
				ex_flag=true
			else
				echo
				echo "$spc Directory $f_name does not exist"
				echo
			fi
		else
			if [ -f "$f_name" ]
			then
				ex_flag=true
			else
				echo
				echo "$spc File $f_name does not exist"
				echo
			fi
		fi
	else
		ex_flag=true
	fi
}


yes_or_no()
{
	confirm=hello
	while [ $confirm != y -a $confirm != n ]
	do
		echo "$1$st_bl\c"
		read confirm
		echo "$norm\c"
		confirm=${confirm:-"n"}
		confirm=`echo $confirm|tr '[A-Z]' '[a-z]'`
		echo
	done
}


find_ubb()
{
	if [ -z "$ubb_path" ]
	then
		echo
		ubb_path=`where.sh ubl x`
		if [ -z "${ubb_path}" ]
		then
		    ubb_path='.'
		else
		    ubb_path=`dirname $ubb_path`
		fi
	fi
}


find_banner()
{
	banners=`where.sh "*.[Bb][Aa][Nn]" f`
	if [ -n "$banners" ]
	then
		ban_name=`ls -t $banners | head -1`
	else
		ban_name=
	fi
}


guess_tdf()
{
	case $TERM in
		vt | vt100 | vt220 | vt320 )		tdf_name=vt220.tdf;;
		an | ans | ansi )			tdf_name=ansi.tdf;;
		wy | wyse | wy60 | wyse60 )		tdf_name=wyse60.tdf;;
		wy50 | wyse50 )				tdf_name=wyse50.tdf;;
		x | xterm )				tdf_name=av300.tdf;;
		ibm3151 | i3151 | 3151 )		tdf_name=ibm3151.tdf;;
		ampex | d80 | dialogue | dialogue80 )	tdf_name=ampex.tdf;;
		dg | d412 )				tdf_name=d412.tdf;;
		d461 )					tdf_name=d461.tdf;;
		* )					tdf_name=vt100.tdf;;
	esac
}


level1()
{
	if [ $quick = false ]
	then
		act_level1
	else
		if [ -z "$ubb_path" ]
		then
			ubb_path=`pwd`
		fi
		level2
	fi
}


act_level1()
{
	choice=""
	find_ubb
	ex_flag1=false
	while [ $ex_flag1 = false -a $completed = false ]
	do
		menu "UBL System Software Directory" "dir" "$ubb_path" Y
		if [ "$choice" != "^" ]
		then
			ubb_path=$choice
			level2
		else
			exit 2
		fi
	done
}


level2()
{
	if [ $quick = false ]
	then
		act_level2
	else
		create_env=`pwd`
		level3
	fi
}


act_level2()
{
	choice=""
	ex_flag2=false
	while [ $ex_flag2 = false -a $completed = false ]
	do
		cls.sh
		heading
		menu "Directory to Create BBENV file" "dir" "`pwd`" Y
		if [ "$choice" != "^" ]
		then
			create_env=$choice
			level3
		else
			ex_flag2=true
			ex_flag1=false
		fi
	done
}


level3()
{
	if [ $quick = false ]
	then
		act_level3
	else
		env_name="BBENV"
		level4
	fi
}


act_level3()
{
	choice=""
	ex_flag3=false
	while [ $ex_flag3 = false -a $completed = false ]
	do
		cls.sh
		heading
		menu "BBENV name :" "file" "BBENV" N
		if [ "$choice" != "^" ]
		then
			env_name=$choice
			level4
		else
			ex_flag3=true
			ex_flag2=false
		fi
	done
}


list_banners()
{
	if [ $# -ge 2 ]
	then
		echo "$spc Banners found are:"
		echo
		for a
		do
			echo "$spc   $a"
		done
		echo
	fi
}


call_secure()
{
	cls.sh
	heading
	echo "$spc No banner file detected."
	echo
	yes_or_no "$spc Do you have the$st_bl Licence Banner Form$norm included with the shipment? (Y/N): "
	if [ $confirm = "y" ]
	then
		secure
		find_banner
		if [ -n "$ban_name" ]
		then
			pause
			level5
		fi
	else
		echo
		echo "$spc Contact Transoft to obtain$st_bl Licence Banner Form$norm."
		pause
		level5
	fi
}


level4()
{
	ex_flag4=false
	while [ $ex_flag4 = false -a $completed = false ]
	do
		find_banner
		if [ -n "$ban_name" ]
		then
			act_level4
		else
			call_secure
		fi
	done
}


act_level4()
{
	choice=""
		cls.sh
		heading
		echo "$spc Setting up banner (BBSIGNON)"
		echo
		list_banners $banners
		menu "Banner name :" "file" "$ban_name" Y "No, its banners"
		if [ "$choice" != "^" ]
		then
			if [ "$choice" = "C" -o "$choice" = "c" ]
			then
				secure
				find_banner
			else
				ban_name=$choice
			fi
			level5
		else
			ex_flag4=true
			ex_flag3=false
		fi
}


level5()
{
	choice=""
	guess_tdf
	ex_flag5=false
	while [ $ex_flag5 = false -a $completed = false ]
	do
		cls.sh
		heading
		echo "$spc Setting up Terminal Definition File (BBTERM)"
		echo
		menu "Terminal Definition File" "file" "$tdf_name" Y "Go for it"
		if [ "$choice" != "^" ]
		then
			tdf_name=$choice
			level6
		else
			ex_flag5=true
			ex_flag4=false
		fi
	done
}


level6()
{
	choice=""
	ex_flag6=false

	lev6_menu
	while [ $ex_flag6 = false ]
	do
		echo "$spc Select option: $st_bl\c"
		read choice
		echo "$norm\c"
		case $choice in
			1 )		precision=4;
					finished;;
			2 )		precision=6;
					finished;;
			3 )		precision=8;
					finished;;

			q | Q )		exit 1;;
			"^" )		ex_flag6=true;
					ex_flag5=false;;
			* )		lev6_menu;;
		esac
	done
}


lev6_menu()
{
	cls.sh
	heading
	echo "$spc Setting up arithmetic precision (BBPRECISION)"
	echo
	echo
	echo "$spc 1)$st_bl Double$norm Precision"
	echo "$spc 2)$st_bl Triple$norm Precision"
	echo "$spc 3)$st_bl Quad$norm Precision"
	echo
	echo "$spc Enter 1, 2 or 3  '^' to GO BACK or 'q' to QUIT"
}


finished()
{
	ex_flag6=true
	completed=true
	build_env
}


ent()
{
	# Write BBENV entry to file
	# echo $1
	echo $1 >> $create_env/$env_name
}


build_env()
{
	echo "# BBENV" > $create_env/$env_name
	ent "BBSEARCH=$ubb_path"
	ent "BBSIGNON=$ban_name"
	ent "BBTERM=$tdf_name"
	ent "BBDEBUG=Y"
	ent "BBLIB=$ubb_path/ubllib"
	ent "BBWINDOWS=Y"
	ent "BBPRECISION=$precision"
	ent "BBERM=$ubb_path/BASIC.ER"
	ent "BBUBLERM=$ubb_path/UBBERM"
	ent "BBLINK=$ubb_path/BBLINKS"
	ent "BBSPOOL=$ubb_path/ublspool.sh"
	ent "BBSHLIB=20000"
	ent "BBHOME=."
	ent "BBROOT=/"
	echo
	echo "BBENV created in $create_env/$env_name"
}


heading()
{
	echo
	echo "$spc$st_us CREATE MINIMUM ENVIRONMENT FILE (BBENV) $norm  Rev $rev"
	echo
}


# Main

if [ "x$1" = "x-q" ]
then
	quick=true
else
	quick=false
fi
rev="1.00"
set_attrs
spc=""
ex_flag=false
ex_flag1=false
ex_flag2=false
ex_flag3=false
ex_flag4=false
ex_flag5=false
ex_flag6=false
completed=false
opt=""
level_back=false
choice=""
create_env=""
env_name=""
ban_name=""
tdf_name=""
precision=0


cls.sh
heading
if [ \( -f BBENV -o -f ./BBENV \) -a $quick = false ]
then
	echo "$spc `pwd`/BBENV already exists."
	yes_or_no "$spc Do you want to over-write? (Y/N): "
	if [ $confirm = "y" ]
	then
		level1
	else
		echo
		echo "$spc User abort."
		echo
	fi
else	
	level1
fi
