#! /bin/sh
#
#   Module name 		: remove.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.3


# Script name : remove.sh
# Purpose     : Removes the UBL System Software Directory
# Author      : S. Roberts
# Revision    : 1.00


PATH=$PATH:. ; export PATH

# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


set_attrs()
{
	case "$TERM" in
		vt100 | vt220 | vt320 | xterm | ansi )
					st_bl=`tput bold 2>/dev/null`;
					st_us=`tput smul 2>/dev/null`;
					norm=`tput sgr0 2>/dev/null`;;

		* )			st_bl=;
					st_us=;
					norm=;;
	esac
}


menu()
{
	echo
	echo "$spc$st_us REMOVE $PROD SYSTEM SOFTWARE DIRECTORY $norm  Rev $rev"
	echo
	echo "$spc DEFAULT $PROD System Software Directory [$st_bl$ubb_path$norm]"
	echo "$spc Enter 'q' to QUIT, '^' to GO BACK, 'd' for DEFAULT or New Directory"
	echo
}


find_version()
{
	# Check if UBL exists
	if [ -$f_type $ubb_path/$f_name ]
	then
		echo
		echo "$spc Do you want to see contents of directory before removing?"
		echo "$spc Enter 'q' to QUIT, '^' to GO BACK, 'y' or 'n' for VIEW"
		ex_flag2=false
		while [ $ex_flag2 = false ]
		do
			back=false
			echo "$spc Select option: $st_bl\c"
			read opt2
			echo "$norm\c"
			case $opt2 in
				q | Q )		exit 1;;
				"^" )		back=true;
						ex_flag2=true;;
				y | Y )		echo;
						ls -C -R $ubb_path | more;
						ex_flag2=true;;
				n | N )		echo;
						ex_flag2=true;;
				"" )		;;
				* )		echo "$spc Do you want to see contents of directory before removing?";
						echo "$spc Enter 'q' to QUIT, '^' to GO BACK, 'y' or 'n' for VIEW";;
			esac
		done
		if [ $back = false ]
		then
			echo
			echo "$spc Are you sure you want to delete $ubb_path?"
			echo "$spc Enter 'q' to QUIT, '^' to GO BACK, 'y' to DELETE"
			ex_flag2=false
			while [ $ex_flag2 = false ]
			do
				echo "$spc Select option: $st_bl\c"
				read opt2
				echo "$norm\c"
				case $opt2 in
					q | Q )		exit 1;;
					"^" )		ex_flag2=true;;
					y | Y )		rm -r $ubb_path;
							echo
							echo "$spc Directory $ubb_path removed";
							ex_flag1=true;
							ex_flag2=true;;
					"")		;;
					* )		echo "$spc Are you sure you want to delete $ubb_path?";
							echo "$spc Enter 'q' to QUIT, '^' to GO BACK, 'y' to DELETE";;
				esac
			done
		fi
	else
		echo
		echo "$spc $PROD not found in directory $ubb_path"
		echo "$spc Aborting."
		exit
	fi
}


# main
rev="1.00"
if [ -n "`pwd | grep usql`" ]
then
	PROD="U/SQL"
	f_name=runusql
	f_type=f
else
	PROD="UBL"
	f_name=ubl
	f_type=x
fi
set_attrs
spc=""
ex_flag1=false
if [ -z "$ubb_path" ]
then
	ubb_path=`where.sh $f_name $f_type`
	if [ -z "${ubb_path}" ]
	then
	    ubb_path='.'
	else
	    ubb_path=`dirname $ubb_path`
	fi
fi
cls.sh
while [ $ex_flag1 = false ]
do
	menu
	echo "$spc Select option: $st_bl\c"
	read opt
	echo "$norm\c"
	case $opt in
		q | Q )		exit 1;;
		"^" )		exit 2;;
		d | D )		find_version;;
		"" )		cls.sh;;
		* )		ubb_path=$opt;
				find_version;;
	esac
done
