#! /bin/sh
#
#   Module name 		: runtime.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.3


# Script name : runtime.sh
# Purpose     : Use UBL Monitor to start and stop runtime.
# Author      : S. Roberts
# Revision    : 1.00


PATH=$PATH:. ; export PATH

# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


set_attrs()
{
	case "$TERM" in
		vt100 | vt220 | vt320 | xterm | ansi )
					st_bl=`tput bold 2>/dev/null`;
					st_us=`tput smul 2>/dev/null`;
					norm=`tput sgr0 2>/dev/null`;;

		* )			st_bl=;
					st_us=;
					norm=;;
	esac
}


menu()
{
	cls.sh
	echo
	echo "$spc        $st_us $PROD RUNTIME ADMINISTRATION $norm  Rev $rev"
	echo
	echo "$spc 1)$st_bl startrun.sh $norm         Start $PROD runtime"
	echo "$spc 2)$st_bl stoprun.sh $norm          Stop $PROD runtime"
	echo "$spc 3)$st_bl runublmon.sh $norm        Run UBLMON"
	echo "$spc 4)$st_bl runubl.sh $norm           Run $PROD"
	echo
	echo "$spc '?' or '<NUMBER>?' for HELP, '^' to GO BACK or 'q' to QUIT\n"
}


pause()
{
	echo
	echo "$spc Press [RETURN] to continue: \c"
	read nothing
}


endhelp()
{
	echo "$spc Press [RETURN] to continue: $st_bl\c"
	read menu_ret
	echo "$norm\c"
}


help_0()
{
	echo
	echo "$spc The $PROD Runtime Administration utility allows the user to"
	echo "$spc start or stop the $PROD runtime, run ublmon or $PROD itself."
	echo
}


help_1()
{
	echo
	echo "$spc This utility prompts the user for the names of a banner file"
	echo "$spc and the $PROD system software directory, in order to start the"
	echo "$spc $PROD runtime using ublmon.  It checks that the run time is"
	echo "$spc not already running before it does this."
	echo
}


help_2()
{
	echo
	echo "$spc This option stops the $PROD runtime."
	echo
}


help_3()
{
	echo
	echo "$spc This option runs ublmon.  First the user is prompted for"
	echo "$spc the name of the $PROD system software directory and then it"
	echo "$spc asks whether ublmon is to be run in windows mode or not."
	echo
}


help_4()
{
	echo
	echo "$spc This option runs $PROD after prompting for the name of the"
	echo "$spc system software directory."
	echo
}


check_4_quit()
{
	if [ $? = "1" ]
	then
		exit 1
	fi
}


# Main
rev="1.00"
if [ -n "`pwd | grep usql`" ] ; then PROD="U/SQL" ; else PROD="UBL" ; fi
set_attrs
spc=""
ex_flag1=false
while [ $ex_flag1 = false ]
do
	menu
	echo "$spc Select option: $st_bl\c"
	read opt
	echo "$norm\c"
	case $opt in
		1 )		startrun.sh;
				check_4_quit;
				pause;;
		2 )		stoprun.sh;
				check_4_quit;
				pause;;
		3 )		runublmon.sh;
				check_4_quit;
				pause;;
		4 )		runubl.sh;
				check_4_quit;
				pause;;

		\? )		help_0;
				endhelp;;
		1\? )		help_1;
				endhelp;;
		2\? )		help_2;
				endhelp;;
		3\? )		help_3;
				endhelp;;
		4\? )		help_4;
				endhelp;;

		"^" )		exit 2;;
		q | Q )		exit 1;;
	esac
done
