#! /bin/sh
#
#   Module name 		: sdcc.sh 
#   Date of last delta		: 9/3/99
#   Release number		: 1.2


# SuperDOS preprocessor (another one)

# This processor will get rid of conditional compilation by changing the
# conditional statements to BASIC ones.
# Turns '>ENDIF' into 'END IF'
# Turns '> IF UNIX = 1' into 'IF UNIX = 1'
#
# There is some code in here to turn '> IF X = T' into '> IF X = 1' and
# does turns '> IF X = F' into 'IF X = 0'. It will only do this if the F or T
# is at the end of the line or followed by ' :'. Not sure why this is.

process_file()
{
	f_name=$1
	tmp_file=/tmp/sdpp.$$
	rm $tmp_file 2>/dev/null

	sed "s/^ *\>endif/END IF/; \
		s/^ *\>ENDIF/END IF/; \
		/^ *\>.*= *[tT][ \:]/s/\= *[tT]/\=1/; \
		/^ *\>.*= *[tT]$/s/\= *[tT]$/\=1/; \
		/^ *\>.*= *[fF][ \:]/s/\= *[fF]/\=0/; \
		/^ *\>.*= *[fF]$/s/\= *[fF]$/\=0/;
		s/^ *\>//" \
				< $f_name > $tmp_file

	mv $tmp_file $a
}

for a in $*
do
	process_file $a
done
