#! /bin/sh
#
#   Module name 		: tdfbuild.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.3


# Script name : tdfbuild
# Description : Call TDF Generator
# Author      : S. Roberts
# Revision    : 1.00
#
# (c) Transoft Ltd 1992
#
#  Options:
#           -v          Verbose
#           filename    Filename for new TDF
#


PATH=$PATH:. ; export PATH

# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


set_attrs()
{
	case "$TERM" in
		vt100 | vt220 | vt320 | xterm | ansi )
					st_bl=`tput bold 2>/dev/null`;
					st_us=`tput smul 2>/dev/null`;
					norm=`tput sgr0 2>/dev/null`;;

		* )			st_bl=;
					st_us=;
					norm=;;
	esac
}


# Main #
verbose=false

if [ "x$1" = "x-v" 2>/dev/null ]
then
	verbose=true
	shift
fi

if [ -n "$1" ]
then
	tdf_file=$1
else
	set_attrs
	echo "Enter TDF filename: $st_bl\c"
	read tdf_file
	echo "$norm\c"
fi

if [ $verbose = true ]
then
	tdfgen > $tdf_file
else
	tdfgen > $tdf_file 2>/dev/null
fi
