#! /bin/sh
#
#   Module name 		: ublsize.sh 
#   Date of last delta		: 12/7/0
#   Release number		: 1.3


# Fix to make Linux "echo" process escape characters
os=`uname -s`
if [ "x${os}" = "xLinux" ]
then
	. linfix.sh
fi


brief=0

if [ $# -ge 1 ]
then
	if [ "x$1" = "x-b" ]
	then
		brief=1
		shift
	fi
fi

if [ $# -eq 1 ]
then
	exename=$1
else
	exename=ubl
fi

if [ ! -x $exename ]
then
	# find executable in path.
	IFS=":"
	found=0
	for i in $PATH
	do
		if [ -x $i/$exename ]
		then
			found=1
			exename=$i/$exename
			break;
		fi
	done
else
	found=1
fi

if [ $found -eq 0 ]
then
	echo Unable to find UBL executable, $exename, in PATH.
	exit 1
fi

if [ $brief -eq 0 ]
then
	echo Using : $exename
	echo
fi
export exename

# get size
# sed line is for xenix which adds hex version too
sizeout=`size $exename 2>/dev/null | tail -1 | sed "s/ = 0x.*//"`
if [ -z "$sizeout" ]
then
	sizeout=`what $exename 2>/dev/null | grep size_info`
	if [ "$sizeout" ]
	then
		sizeout=`echo $sizeout | sed "s/.*size_info.c//"`
	else
		echo "size command failed on $exename."
		file $exename
		exit 1
	fi
fi

SizeWc=`echo $sizeout | wc -w`
if [ $SizeWc -ne 7 ]
then
	if [ $SizeWc -eq 5 ]
	then
		# Probably on a DEC ALPHA
		sizeout=`echo $sizeout | awk '{ print $1 " + " $2 " + " $3 " = " $1 + $2 + $3 }'`

	else
		#must be on AIX
		sizeout=`echo $sizeout | awk '{ print $4 " + " $8 " + " $10 " = " $4 + $8 + $10 }'`
	fi
fi

# display result
if [ $brief -eq 1 ]
then
	echo $sizeout
else
	echo $sizeout | awk '{ print "UBL executable size = "$1"\nStatic data size    = " $3 + $5 }'
fi
